/*--------------------------------------------------------------------
  gval module.

    Copyright (C) 1998,1999
        SASAKI Shunsuke <ele@pop17.odn.ne.jp> All rights reserved. 
--------------------------------------------------------------------*/
#include	"config.h"

#include	<stdio.h>
#include	<string.h>
#include	"generic.h"
#include	"gval.h"


	/* gval */

gval_t	*gval_init(gval_t *gvp,int m)
{
	if (gvp==NULL)
		{
		 gvp= (gval_t *)malloc(sizeof(gval_t));
		 if (gvp==NULL)
		 	error("gval_init :malloc failed");
		}

	gvp->item=(gval_item_t *)malloc(sizeof(gval_item_t)* m);
	if (gvp->item==NULL)
		error("gval_init :malloc failed");

	gvp->num=0;
	gvp->max=m;

	return gvp;
}

void	gval_fin(gval_t *gvp)
{
	free(gvp->item);
	gvp->num=0;
	gvp->max=0;
}

char	*gval_get(gval_t *gvp, const char *ks)
{
	int 	i;

	for (i=0; i<gvp->num; ++i)
		{
		 if (strcasecmp(gvp->item[i].key, ks)==0)
		 	return gvp->item[i].val;
		}
	return NULL;
}

void	gval_set(gval_t *gvp, const char *ks,const char *vs)
{
	char	*p;

	p=gval_get(gvp, ks);
	if (p==NULL)
		{
		 if (gvp->num>= gvp->max)
		 	{
//		 	 warning("gval_defset :member is over");
		 	 return;
		 	}
		 strjncpy(gvp->item[gvp->num].key, ks, LN_key);
		 p=gvp->item[gvp->num].val;
		 ++gvp->num;
		}

	strjncpy(p, vs, LN_val);
}

void	gval_defset(gval_t *gvp, const char *ks, const char *vs)
{
	char	*p;

	p=gval_get(gvp, ks);
	if (p!=NULL)
		return;
	if (gvp->num>=gvp->max)
		{
//		 warning("gval_defset :member is over");
		 return;
		}

	strjncpy(gvp->item[gvp->num].key, ks, LN_key);
	strjncpy(gvp->item[gvp->num].val, vs, LN_val);
	++gvp->num;
}

bool	gval_istrue(gval_t *gvp, const char *ks)
{
	const char	*p;

	p=gval_get(gvp, ks);
	return p!=NULL&&(strcasecmp(p,"true")==0|| strcasecmp(p,"on")==0);
}

void	gval_view(gval_t *gvp)
{
	int 	i;

	fprintf(stderr,"gval: %p(%d/%d)\n",gvp, gvp->num, gvp->max);

	for (i=0;i<gvp->num;++i)
		fprintf(stderr,"%2d:[%s][%s]\n",i,gvp->item[i].key,gvp->item[i].val);
}

