/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:crt.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01

    Copyright (C) 1998,1999
        SASAKI Shunsuke <ele@pop17.odn.ne.jp> All rights reserved. 
--------------------------------------------------------------------*/
#include "ed.h"
#include <ctype.h>


extern	void	system_guide();



void	widthputs(const char *s,size_t len)
{
	char	buf[MAXLINESTR+1];

	strjfcpy(buf,s,MAXLINESTR,len);
	term_puts(buf);
}



void	crt_crmark()
{
	term_color(sysinfo.c_crmark);
	term_putch('!');

	term_color_normal();
}



typedef	struct
{
	int 	dline;
	long	line;
	long	blk_st;
	long	blk_ed;
}	crt_draw_t;

void	crt_draw_proc(const char *s,crt_draw_t *gp)
{
	char	buf[MAXEDITLINE+1];
	char	buf_dsp[MAXEDITLINE+1],*p;
	bool	cf;
	int 	ln,sx,n,m;

	p=buf_dsp;
	cf=FALSE;
	if (s==NULL)
		strcpy(buf_dsp,"~"); else
		{
		 if (gp->dline==GetRow())
		 	strcpy(buf,csrle.buf); else
		 	strcpy(buf,s);

		 if (*s=='\0'|| s[strlen(s)-1]!='\n')
		 	strcat(buf,"[EOF]"); else
		 	cf=TRUE;

		 if (*buf!='\0'&& buf[strlen(buf)-1]=='\n')
		 	 buf[strlen(buf)-1]='\0';
		 ln=le_regbuf(buf,p);

		 sx=GetScroll();
		 n =kanji_poscandisp(sx, p);
		 if (sx>0) 
		 	{
		 	 m= kanji_posbuf(n, p);
		 	 if (m==ln)
		 	 	sx =ln; else
		 	 	{
		 	 	 if (sx!=n)
		 	 	 	memset(p+m, ' ', kanji_countbuf(p[m]));
		 	 	 sx=kanji_posbuf(sx, p);
		 	 	}
		 	 p+=sx;
		 	}
		}

	if (sysinfo.numberf)
	{
		term_locate(gp->dline, GetMinCol());
		term_color(sysinfo.c_linenum);
		term_printf("%5ld:", gp->line);
	}

	term_locate(gp->dline, GetMinCol()+ NumWidth);
	term_color_normal();

	if (s!=NULL&& block_ismode()&&
			gp->line >=gp->blk_st && gp->line <=gp->blk_ed)
		{
		 term_color(sysinfo.c_block);
		 cf=FALSE;
		}

	n=kanji_posbuf(kanji_poscandisp(GetColWidth()- NumWidth, p),p);
	if (p[n]!='\0')
		cf=FALSE;
	p[n]='\0';
	term_puts(p);

	if (cf&& sysinfo.crmarkf)
		crt_crmark();

	term_clrtoe();

	++gp->line;
	++gp->dline;
}

void	crt_ledraw()
{
	crt_draw_t	cd;
	char	buf[MAXEDITLINE+1];

	cd.line=GetLineOffset();
	cd.dline=GetRow();
	if (block_ismode())
		{
		 cd.blk_st=GetBlockStart();
		 cd.blk_ed=GetBlockEnd();
		}

	if (cd.line>=GetLastNumber())
		strcpy(buf,csrle.buf); else
		sprintf(buf,"%s\n",csrle.buf);

	crt_draw_proc(buf,&cd);
}

void	CrtDrawAll()
{
	crt_draw_t	cd;
	int 	lline,sline;


	term_color_normal();
	system_guide();

	if (block_ismode())
		{
		 cd.blk_st=GetBlockStart();
		 cd.blk_ed=GetBlockEnd();
		}

	cd.dline=GetMinRow();
	lline=GetRowWidth();

//			(!GetBlockFlg() || csrse.l_cy==csrse.cy))
	if (!csrse.uf&& csrle.l_sx==csrle.sx&& !GetBlockFlg())
		{
		 if (csrse.l_sy==csr_getsy())
		 	return ;
		 sline=csrse.l_sy-csr_getsy();
		 if (abs(sline)<4)	// customize Ǥ褦ˤ롣
		 	{
		 	 int 	i;

			 term_locate(GetMinRow(), GetMinCol());
		 	 if (sline<0)
		 	 	{
				 for (i=0;i<0-sline;++i)
				 	term_delln();
				 cd.dline=GetRowWidth()+sline+1;
		 	 	} else
		 	 	{
				 for (i=0;i<sline;++i)
				 	term_insln();
				 lline=cd.dline+sline-1;
		 	 	}
		 	}
		}

	term_csrh();
	cd.line=csr_getsy()+cd.dline;
	lists_proc(crt_draw_proc,&cd, cd.line, cd.line+lline-cd.dline);
	term_csrn();

	csrse.uf=FALSE;
	csrle.l_sx=csrle.sx;
	csrse.l_sy=csr_getsy();
	csrse.l_cy=csrse.cy;
}



void	BelowLineDraw()
{
	crt_draw_t	cd;
	char	buf[MAXEDITLINE+1],*p;

	cd.line =GetLineOffset() + (GetRowWidth() - GetRow());
	cd.dline=GetMaxRow();
	if (block_ismode())
		{
		 cd.blk_st=GetBlockStart();
		 cd.blk_ed=GetBlockEnd();
		}

	if (cd.line>GetLastNumber())
		p=NULL; else
		{
		 EditLine	*ed;

		 ed=GetList(cd.line);
		 if (ed->next==NULL)
		 	strcpy(buf,ed->buffer); else
		 	sprintf(buf,"%s\n",ed->buffer);
		 p=buf;
		}

	crt_draw_proc(p,&cd);
}



void	LineNumberDraw()	/* ֹ椬ΤƷ׻ */
{
	 int MaxRow;
	 int number;
	 long LineNumber;
	 long LastOffset;

	if (sysinfo.numberf) {
		MaxRow = GetMaxRow();
		LineNumber = GetLineOffset()-(GetRow()-GetMinRow());
		LastOffset = GetLastNumber();
		for (number = GetMinRow(); number <= MaxRow; number++, LineNumber++) {
			term_locate(number, GetMinCol());
			term_color(sysinfo.c_linenum);
			if (LineNumber <= LastOffset) {
				term_printf("%5ld:", LineNumber);
			} else {
				term_clrtoe();
				term_putch('~');
			}
		}
	}
}

void	DeleteAndDraw()
{

	term_locate(GetRow(), GetMinCol());
	term_delln();
	BelowLineDraw();
	LineNumberDraw();
	crt_ledraw();
}

void	InsertAndDraw()
{
	term_locate(GetRow(), GetMinCol());
	term_insln();
	LineNumberDraw();
	crt_ledraw();
}

void	RefreshMessage()
{
	if (OnMessage_Flag)
	{
		OnMessage_Flag = FALSE;
		BelowLineDraw();
		*sysinfo.systemline='\0';

		if (sysinfo.sl_drp!=NULL)
			{
			 disp_regfin(sysinfo.sl_drp);
			 sysinfo.sl_drp=NULL;
			}
	}
}


/*-------------------------------------------------------------------
	Put Guide Line
------------------------------------------------------------------*/
#define	LN_guide	34

dispfmt_t	*dispreg_guide(void *vp,int a,int sizex,int sizey)
{
	dispfmt_t	*dfp,*dfpb;
	char		*p,tmp[80+1],tmp2[16+1];
	int 		length;
	int 		cn;

	char		kc_char[]={'E','J','S'};
	char		rm_char[]={'L','+','C'};


	if (FILE_START > CurrentFileNo)
		return FALSE;

	if (sizex<=LN_guide)
		{
		 dfp=disp_fmtinit("",NULL);
		 dfp->col.rf=TRUE;
		 return dfp;
		}


	if (ef[CurrentFileNo].pm)
		dfp=disp_fmtinit("S",NULL); else
		{
		 dfp=disp_fmtinit("P",NULL);
		 dfp->col.rf=TRUE;
		}
	dfpb=dfp;

	if (sysinfo.overwritef)
		dfp=disp_fmtinit("R",dfp); else
		{
		 dfp=disp_fmtinit("i",dfp);
		 dfp->col.rf=TRUE;
		}


	if (GetBufferOffset()>=strlen(csrle.buf))
		cn=0; else
		{
		 cn=csrle.buf[GetBufferOffset()]&0xff;
		 if (iskanji(cn))
		 	cn=(cn<<8) + (csrle.buf[GetBufferOffset()+1]&0xff);
		}

	if (*sysinfo.doublekey!='\0')
		strcpy(tmp2,sysinfo.doublekey); else
		sprintf(tmp2,"%04x",cn);

	p = ef[CurrentFileNo].path;
	length = strlen(p);
	if (sizex-LN_guide < length)
		p += length-(sizex-LN_guide);

	sprintf(tmp, " %04d/%3d%%:%03d[%4.4s]%6d %2d%c%c%c%s"
			,GetLineOffset()
			,GetLineOffset()==1 ?0:GetLineOffset()*100/GetLastNumber()
			,le_getcsx(&csrle)
			,tmp2
			,csrse.bytes+GetLastNumber()-1
			,CurrentFileNo-FILE_START+1
			,kc_char[ef[CurrentFileNo].kc]
			,rm_char[ef[CurrentFileNo].rm]
			,ef[CurrentFileNo].cf? '*':':'
			,p
		);

	dfp=disp_fmtinit(tmp, dfp);
	dfp->col.rf=TRUE;

	return dfpb;
}

void	putDoubleKey(int key)
{
	sprintf(sysinfo.doublekey,"^%c  ", key+'@');
}

void	delDoubleKey()
{
	*sysinfo.doublekey='\0';
}

void	system_guide_init()
{
	dispreg_t	*drp;

	drp=disp_reginit();
	drp->sizey=1;
	drp->func=dispreg_guide;

	disp_regadd(drp);
}

void	system_guide()
{
	disp_allview();
}


dispfmt_t	*dispreg_sysmsg(void *vp,int a,int sizex,int sizey)
{
	dispfmt_t	*dfp;

	dfp=disp_fmtinit(sysinfo.systemline, NULL);
	memcpy(&dfp->col, &sysinfo.c_sysmsg, sizeof(color_t));

	return dfp;
}


void	system_msg(const char *buffer)	// Ūdisp
{
	OnMessage_Flag = TRUE;

	strcpy(sysinfo.systemline, buffer);

	if (*buffer=='\0')
		{
		 term_locate(GetMaxRow(), GetMinCol());
		 term_clrtoe();

		 return;
		}

	if (sysinfo.sl_drp!=NULL)
		disp_regfin(sysinfo.sl_drp);


	sysinfo.sl_drp=disp_reginit();
	sysinfo.sl_drp->y    =dispall.sizey-1;
	sysinfo.sl_drp->sizey=1;
	sysinfo.sl_drp->func =dispreg_sysmsg;

	disp_regadd(sysinfo.sl_drp);

	disp_regview(sysinfo.sl_drp, TRUE);


	term_color_normal();
	term_locate(GetMaxRow(), GetMinCol()+strlen(buffer));
	term_flush();
}

