/*--------------------------------------------------------------------
  Terminal Module.
    based on NxEdit2.04    ::term.h
             FD clone 1.03g::term.h

    Copyright (C) 1999
        SASAKI Shunsuke <ele@pop17.odn.ne.jp> All rights reserved. 
--------------------------------------------------------------------*/
#ifndef	__TERM_H_
#define	__TERM_H_

#define	CR	'\r'
#define	ESC	'\033'

#define	K_MIN	K_NOKEY
#define	K_NOKEY	0401
#define	K_DOWN	0402
#define	K_UP	0403
#define	K_LEFT	0404
#define	K_RIGHT	0405
#define	K_HOME	0406
#define	K_BS	0407
#define	K_F0	0410
#define	K_F(n)	(K_F0 + (n))
#define	K_DL	0510
#define	K_IL	0511
#define	K_DC	0512
#define	K_IC	0513
#define	K_EIC	0514
#define	K_CLR	0515
#define	K_EOS	0516
#define	K_EOL	0517
#define	K_ESF	0520
#define	K_ESR	0521
#define	K_NPAGE	0522
#define	K_PPAGE	0523
#define	K_STAB	0524
#define	K_CTAB	0525
#define	K_CATAB	0526
#define	K_ENTER	0527
#define	K_SRST	0530
#define	K_RST	0531
#define	K_PRINT	0532
#define	K_LL	0533
#define	K_A1	0534
#define	K_A3	0535
#define	K_B2	0536
#define	K_C1	0537
#define	K_C3	0540
#define	K_BTAB	0541
#define	K_BEG	0542
#define	K_CANC	0543
#define	K_CLOSE	0544
#define	K_COMM	0545
#define	K_COPY	0546
#define	K_CREAT	0547
#define	K_END	0550
#define	K_EXIT	0551
#define	K_FIND	0552
#define	K_HELP	0553
#define K_SLEFT	0611
#define K_SRIGHT	0622
#define K_UNDO	0630
#define	K_MAX	K_UNDO



#ifdef	CTRL
#undef	CTRL
#endif
#define	CTRL(c)	((c) & 037)



extern int n_column;
extern int n_line;

#ifndef	SENSEPERSEC
#define	SENSEPERSEC	50
#endif
#ifndef	WAITKEYPAD
#define	WAITKEYPAD	360		/* msec */
#endif



extern	void	term_init();

extern	void	term_start(int mode);
extern	void	term_stop();
extern	int 	term_getmode();
extern	void	term_setmode(int mode);

extern	void	term_kflush();
extern	int 	term_dputc(int c);
extern	int 	term_getch();
extern	int 	term_kbhit(u_long usec);
extern	void	term_flush();
extern	void	term_insln();
extern	void	term_delln();
extern	void	term_bell();
extern	void	term_csrf();
extern	void	term_csrn();
extern	void	term_csrh();


extern	int 	inkey();
extern int getwsize(int, int);


#define	TM_keypad		1
#define	TM_init			2
#define	TM_tinit		4
#define	TM_ansicolor	8


typedef	struct
{
	uint	fc:3;	/* ʿ */
	uint	bc:3;	/* طʿ */
	uint	rf:1;	/* ȿž   */
	uint	uf:1;	/*    */
	uint	bf:1;	/*    */
}	color_t;

#define	AC_black	0
#define	AC_red		1
#define	AC_green	2
#define	AC_yellow	3
#define	AC_blue		4
#define	AC_magenta	5
#define	AC_cyan		6
#define	AC_white	7

extern	color_t	term_cftocol(const char *s);
extern	bool	col_cmp(color_t cola,color_t colb);

extern	void		term_color(color_t c);
extern	void		term_color_normal();
extern	void		term_color_fc(int fc);
extern	void		term_color_underline();
extern	void		term_color_reverse();
extern	void		term_color_bold();


extern	void		term_locate(int y,int x);
extern	void		term_cls();
extern	void		term_clrtoe();
extern	void		term_movex(int x);
extern	int 		term_puts(char *s);
extern	int 		term_putch(int c);
extern	int 		term_printf(const char *fmt,...);


typedef	struct
{
	char	*name;
	int 	scode;
}	keysdef_t;

extern	keysdef_t	keysdef[];


#define	MAX_keys	1024

typedef	struct
{
	char	*seq;
	int 	scode;

	int 	len;
}	keys_t;

extern	keys_t	keys[MAX_keys];
extern	int 	keys_num;

extern	void	keys_set(const char *k, const char *e);
extern	int 	keys_getname(const char *s);


extern	void	keyf_set(int region,const char *k,const char *s);
extern	int 	keyf_getname(const char *s,int n);




#endif	/* __TERM_H_ */
